﻿/*08101 - Programming 1 - University Of Hull, Computer Science, Year 1.
 SPACE CHEESE BATTLE - Vers 1.4
 
 Created by ADAM CONNOR LUTTON
 
 Patch Notes and TODO List at the bottom*/

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace SpaceCheeseGame
{
    class Program
    {

        static int[] cheeseSquares = new int[]                               //Squares which activate Cheese Powers.
        { 
            8, 15, 19, 28, 33, 45, 55, 59 
        };

        struct Player
        {
	        public string Name;
	        public int Position;
        }

        static int numberOfPlayers = 0;
        static Player[] player = new Player[4];
        static bool gameOver = GameOver();                                   //Public variable relating to whether the game is over or not.


        static bool GameOver()                                               //Returns true if triggered.
        {
            for (int i = 0; i < numberOfPlayers; i++)
            {
                if (player[i].Position == 64)//Adjusted for exact square No.
                    return true;
            }
            return false;
        }


        static int WhichPlayerWon()                                          //Detection system for which player won, displays the player No in the GameOverScreen method.
        {
            for (int i = 0; i < numberOfPlayers; i++)
            {
                if (player[i].Position >= 64)
                    return i;
            }
            return 99;//Error value.
        }


        static void ResetGame()                                             //Resets all game value.
        {
            ReadNumber("Enter the number of players : ", 2, 4);
            PlayerNames();

            for (int i = 0; i < numberOfPlayers; i++)
            {
                player[i].Position = 0;
            }
        }


        static void PlayerNames()                                           //Takes in player names.
        {
            for (int i=0; i < numberOfPlayers; i++)
            {
                Console.WriteLine("\n Please Enter Player " + (i + 1) + "'s name: ");
                player[i].Name = Console.ReadLine().ToUpper();
                Console.WriteLine("");
                Console.WriteLine("The name for player " + (i + 1) + " is " + player[i].Name);
            }
        }


        static int ReadNumber(string prompt, int MIN, int MAX)              //Reads in the amount of players playing.
        {
            Console.Write(prompt);

            do
            {
                string numberOfPlayersString = Console.ReadLine();

                try
                {
                    numberOfPlayers = int.Parse(numberOfPlayersString);
                }
                catch
                {
                    Console.WriteLine("Invalid Value, try again.");
                    continue;
                }

            } while (numberOfPlayers < MIN || numberOfPlayers > MAX);

            return numberOfPlayers;
        }


        static Random diceRandom = new Random();


        static int DiceThrow()
        {
            int spots = diceRandom.Next(1, 6);
            return spots;
            //return 1;
            /*The program only uses "return 1" for testing purposes*/
        }


        static bool RocketInSquare(int squareNo)
        {
            for (int i = 0; i < numberOfPlayers; i++)
            {
                if (player[i].Position == squareNo)
                    return true;
            }
            return false;
        }


        static bool CheesePowerSquare(int squareNo)
        {
                                                                       //Method that checks through the 
                                                                       //cheese square positions and returns true if the square has cheese power
            for (int i = 0; i < numberOfPlayers; i++)
            {
                for (int j = 0; j < 8; j++)
                {
                    if (player[i].Position == squareNo && squareNo == cheeseSquares[j])
                        return true;
                }
            }
            return false;
        }


        static void CheeseSwap(int playerNo, int swapNo)                //Takes in the number of the player and the number of the player they want to swap with, and switches their positions.
        {
            int goodPlayer = player[playerNo].Position;
            int badPlayer = player[swapNo].Position;

            player[playerNo].Position = badPlayer;
            player[swapNo].Position = goodPlayer;
        }


        static void PlayerInputCheck()
        {
            Console.WriteLine("\n Press the ENTER key to roll again");
            string playerInput = Console.ReadLine();
        }


        static void PlayerTurn(int PlayerNo)                                        //PlayerTurn method for one player which is fed in through the MakeMove method.
        {
            int diceDisplay = DiceThrow();
            int potentialPosition = player[PlayerNo].Position + DiceThrow();
            while (RocketInSquare(potentialPosition))
            {
                Console.WriteLine("Rocket In Square " + potentialPosition + ", bounced to square " + (potentialPosition + 1) + ".");        //Player bouncing off another player and moving a square ahead.
                potentialPosition += 1;
            }
            if (potentialPosition > 64)
            {
                Console.WriteLine("Hit the end of the Universe, and bounced back " + BounceBackFromEnd(potentialPosition, 64) + " squares.");  //Detection of when the player goes over square 64.
                potentialPosition = potentialPosition - BounceBackFromEnd(potentialPosition, 64);
                while (RocketInSquare(potentialPosition))
                {
                    Console.WriteLine("Rocket In Square " + potentialPosition + ", bounced to square " + (potentialPosition - 1) + ".");        //Rocket in square detection, but moves the player back one sqaure instead of forward.
                    potentialPosition -= 1;
                }
            }

            player[PlayerNo].Position = potentialPosition;

        }


        static int BounceBackFromEnd(int position, int totalSquares)
        {
            int amountToBeBouncedBack = position - totalSquares;

            return amountToBeBouncedBack;
        }


        static void StatusScreen()
        {
            Console.WriteLine("========================\n   SPACE CHEESE BATTLE\n========================\n=====CURRENT STATUS=====");
            for (int i = 0; i < numberOfPlayers; i++)
            {
                Console.WriteLine("Player " + (i+1) + " (" + player[i].Name + ") is on Square " + player[i].Position);
            }
        }


        static void MakeMove(int playerNo)                          //Calls the PlayerTurn with the number of the player that is fed in.
        {
            PlayerTurn(playerNo);
        }


        static void GameOverScreen()
        {
            Console.WriteLine("GAME OVER \n Player " + (WhichPlayerWon() + 1) + " (" + player[WhichPlayerWon()].Name + ") " + " has won. \n Would you like to play again? (Press Y to Restart, any other key to end)");
            string endGameSelection = Console.ReadLine().ToUpper();
            if (endGameSelection == "Y")
                Main(); //Repeats the whole program over again.
        }


        static void IfCheesePowerHit(int i)                                             //Method for asking the player if they would like to swap or roll again, and calls the relevant functions.
        {
            Console.WriteLine("Cheese Square Hit \n");
            StatusScreen();
            Console.WriteLine("\n Would you like to SWAP (Press 'S') or ROLL AGAIN (Press 'R')");
            string CheeseChoice = Console.ReadLine().ToUpper();

            if (CheeseChoice == "S")
            {
                Console.WriteLine("\n What player (1-4) would like to swap with?");

                string CheeseSquareSwapChoiceString = Console.ReadLine();
                int CheeseSquareSwapChoice = int.Parse(CheeseSquareSwapChoiceString);

                CheeseSwap(i, (CheeseSquareSwapChoice - 1));
                Console.WriteLine("#SWAPPED WITH PLAYER " + CheeseSquareSwapChoice + "#");

            }
            else if (CheeseChoice == "R")
            {
                MakeMove(i);
                Console.WriteLine("\n Player " + (i + 1) + " (" + player[i].Name + ") is on position " + player[i].Position + "\n");
            }
            else
            {
                Console.WriteLine("Invalid command, Cheese Power skipped!");
            }
        }


        static void Main()
        {
            Console.Clear();
            Console.WriteLine("SPACE CHEESE BATTLE! \n -Created by Adam Connor Lutton \n -Original Gameplay Design by Dr. Robert Miles");
            ResetGame();
            Console.WriteLine("\n Press ENTER to begin the game and roll the dice for the first time! \n Good luck, and have fun!");
            Console.ReadLine();

            while (GameOver() == false)
            {
                Console.Clear();//Clears the console screen, making it easier to read.
                for (int i = 0; i < numberOfPlayers; i++)
                {
                    MakeMove(i);
                    Console.WriteLine("Player " + (i + 1) + " (" + player[i].Name + ") is on position " + player[i].Position);
                    
                    if (CheesePowerSquare(player[i].Position) == true)
                    {
                        IfCheesePowerHit(i);
                    }
                    Console.WriteLine("\n PRESS ENTER");
                    Console.ReadLine();
                }
                StatusScreen();
                PlayerInputCheck();
                Console.Clear();
            }
            GameOverScreen();//GameOverScreen displays once "GameOver() == true"
        }
    }

}

/*====================================================================================
 TODO:
 * 
 * 
 
 =====================================================================================*/

//Patch Notes:
/*===================================================================================
 
    *1.1 = Total re-write of code. Improving all methods, and optimizing the usability and performance.
    *1.2 = Complete Program to spec.
    *1.3 = Exact score to win.
    *1.4 = Comments, minor corrections and improvements.

  ===================================================================================
*/